<?php

class Admin_CustomPostType_Forms extends Admin_CustomPostType {
        var $forms;
	function __construct() {
            global $smp_forms;
            
            $this->albums = $this->album_list();

            array_unshift($this->albums,array('name' => 'Select Album', 'value' => ''));

            $this->templates = $this->get_smp_templates(TEMPLATE_DIR,'album','Album Template Name');
            array_unshift($this->templates,array('name' => 'Select Template', 'value' => ''));

            $this->page_templates = $this->get_smp_templates(TEMPLATE_DIR, 'page', 'SmugPress Template Name');
            array_unshift($this->page_templates,array('name' => 'Default', 'value' => 'default'));
            
            $this->forms = new Admin_Forms( $this->smp_album_meta_boxes() );
            
            //if($_POST['smp_custom_post_template']) {
                //add_action('save_post',array(&$smp_forms,'smp_save_form'),5,1);
            //}

	}
	public function renderer($layout=false) {
            $this->class = get_class();
            $this->render($layout,$this->class);
	}
	function page_meta_boxes() {
            global $post;
            //global $smp_forms;
            
            $this->post = $post;
            
            //print_r($_POST);
            
            $meta_boxes = $this->smp_album_meta_boxes();
            
            $this->forms->smp_form_table($meta_boxes);
            //$smp_forms->smp_form_table($meta_boxes,1);
            
            //$this->renderer('form-table');
		
	}
	function smp_album_meta_boxes() {
		global $post;
		/* Array of the meta box options. */
		$meta_boxes = array(
                    'page_template' => array( 'name' => 'smp_custom_post_template', 'options' => $this->page_templates, 'title' => __('Page Template', 'smp'), 'type' => 'select' ),
                    'album' => array( 'name' => 'smp_album_id_key', 'options' => $this->albums, 'title' => __('Album', 'smp'), 'type' => 'select' ),
                    'album_template' => array( 'name' => 'smp_album_template', 'options' => $this->templates, 'title' => __('Album Template', 'smp'), 'type' => 'select' ),
	
		);

		return apply_filters( 'smp_post_meta_boxes', $meta_boxes );
	}
	
	function album_list() {
		global $f;
		
		$albums = $f->albums_get();
		
		for($j = 0; $j < count($albums); $j++) {
			$result_list[$j]['value'] = $albums[$j]['id'] . '|' . $albums[$j]['Key'];
			$result_list[$j]['name'] = $albums[$j]['Title'];
		}
		return $result_list;
	}
	
	function get_file_extension($file_name) {
		return substr(strrchr($file_name,'.'),1);
	}
	
	function directory_list($directory_base_path,$type) {
		$directory_base_path = rtrim($directory_base_path, "/") . "/";
		
		 // create an array to hold directory list
	    $results = array();
	
	    // create a handler for the directory
	    $handler = opendir($directory_base_path);
		$i = 0;
	    // open directory and walk through the filenames
	    while ($file = readdir($handler)) {
			$extension = $this->get_file_extension($file);

		    // if file isn't this directory or its parent, add it to the results
		    if(!is_dir($directory_base_path . $file) && $extension == 'php') {
			    if ($file != "." && $file != "..") {
					$withoutExt = pathinfo($file, PATHINFO_FILENAME);
					$results[] = $withoutExt;
				}
		    }
		    $i++;
	    }
	
	    // tidy up: close the handler
	    closedir($handler);
	
	    // done!
	    return $results;
	}
	/**
	 * Loops through each meta box's set of variables.
	 * Saves them to the database as custom fields.
	 *
	 * @since 0.3
	 * @param int $post_id
	 */
	function smp_save_meta_data( $post_id ) {
            global $post;

            if ( 'smp-album' == $_POST['post_type'] ) {
                $meta_boxes = $this->smp_album_meta_boxes();
            }

            foreach ( $meta_boxes as $meta_box ) {

                if ( !wp_verify_nonce( $_POST[$meta_box['name'] . '_noncename'], $meta_box['name'] ) )
                    return $post_id;

                if ( 'smp-album' == $_POST['post_type'] && !current_user_can( 'edit_page', $post_id ) )
                    return $post_id;

                $data = stripslashes( $_POST[$meta_box['name']] );

                $smp_post_meta = get_post_meta( $post_id, $meta_box['name'], true );

                if ( $smp_post_meta == '' )
                    add_post_meta( $post_id, $meta_box['name'], $data, true );

                elseif ( $data != $smp_post_meta )
                    update_post_meta( $post_id, $meta_box['name'], $data );

                elseif ( $data == '' )
                    delete_post_meta( $post_id, $meta_box['name'], get_post_meta( $post_id, $meta_box['name'], true ) );

            }
	}
	
}
global $custom_post_type_forms;
$custom_post_type_forms = new Admin_CustomPostType_Forms();