<?php

class Admin_CustomPostType extends SmugPress {
	var $albums;
	var $templates;
	function __construct() {
		add_action( 'init', array(&$this, 'create_post_type') );
		add_action('admin_menu',array(&$this,'add_options_to_page'));
		add_action('template_redirect', array(&$this,'my_template'), 5);
		register_activation_hook(__FILE__, array(&$this,'smp_rewrite_flush') );
		$this->default_template();
	}
	function smp_rewrite_flush() {
	  $this->create_post_type();
	  flush_rewrite_rules();
	}
	function create_post_type() {
		$labels = array(
                    'name' => __( 'SmugMug Galleries' ),
                    'singular_name' => __( 'SmugMug Gallery' ),
                    'add_new' => __( 'Add Gallery' ),
                    'view_item' => __('View Galleries'),
                    'search_items' => __('Search Galleries'),
                    'add_new_item' => __( 'Add New Gallery' ),
                    'edit_item' => __( 'Edit Gallery' ),
                    'menu_name' => __( 'Galleries' ),
                    );
		$args = array(
                    'labels' => $labels,
                    'public' => true,
                    'has_archive' => true,
                    'hierarchical' => true,
                    'capability_type' => 'page',
                    'supports' => array(
                        'title',
                        'editor',
                        'page-attributes'
                        ),
                    'rewrite' => array(
                        'slug' => 'galleries'
                        ),
                    );
		register_post_type( 'smp-album',$args );
	}
	public function add_options_to_page() {
		global $custom_post_type_forms;
		//print_r($this->templates);
		add_meta_box( 'smugpress-meta-boxes', __('SmugPress Options'), array(&$custom_post_type_forms,'page_meta_boxes'), 'smp-album', 'side', 'default' );
	}
	function default_template() {
		global $post;
		
		$album_template = get_post_meta($post->ID,'smp_custom_post_template',true);
		
		if ( $album_template == '' )
			add_post_meta( $post->ID, 'smp_custom_post_template', 'default', true );
			
	}
	function my_template() {
		global $post;
		
		$post_type = get_query_var('post_type');
		
		$album_template = get_post_meta($post->ID,'smp_custom_post_template',true);
		
		$default_template = get_template_directory() . '/page.php';
		
		//print_r($default_template);
		
		if ($post_type == 'smp-album') {  // check your post type
				//print_r(TEMPLATE_DIR);
				if($album_template != 'default') {
					load_template(TEMPLATE_DIR . $album_template . '.php');					
				} else {
					load_template($default_template);	
				}

			exit;
	
		}
	
	}
	function get_smp_templates($template_dir,$type=false,$name) 
	{
		//global $custom_post_type_forms;
		if($type == 'album') {
			//echo 'hey there';
			$template_dir = $template_dir .'albums/';
		}
		$templates = $this->directory_list($template_dir,$type);
		
		$post_templates = array();
		
		if ( is_array( $templates ) ) {
			//$base = $template_dir;//array( trailingslashit(get_template_directory()), trailingslashit(get_stylesheet_directory()) );
			/*if($type == 'album') {
				//echo 'hey there';
				$templates = $this->directory_list($template_dir .'albums',$type);
			} else {
				$templates = $this->directory_list($template_dir,$type);
			}*/
			
			$j = 0;
			foreach ( $templates as $template ) {
				$basename = $template_dir . $template.'.php';//str_replace($base, '', $template['value'].'.php');
				//print_r($basename);
				
				// don't allow template files in subdirectories
				//if ( false !== strpos($basename, '/') )
					//continue;

				// Get the file data and collapse it into a single string
				$template_data = implode( '', file( $basename ));
				
				//$name = '';
				if ( preg_match( '|'.$name.':(.*)$|mi', $template_data, $name ) )
					$name = _cleanup_header_comment( $name[1] );

				if ( !empty( $name ) && !is_array($name) ) {
					$post_templates[$j]['value'] = $template;
					$post_templates[$j]['name'] = $name;
				}
					//$post_templates[trim( $name )] = $basename;
					
				//echo '<pre>';
				//print_r($post_templates);
				//echo '</pre>';
				//print_r($name);
				$j++;
			}
		}

		return $post_templates;
	}
}
global $custom_post_type;
$custom_post_type = new Admin_CustomPostType();
