<?php

// This is a helper class to make paginating 
// records easy.
class SMP_Pagination {
	
  public $current_page;
  public $per_page;
  public $total_count;

  public function __construct($page=1, $per_page=20, $total_count=0){
  	$this->current_page = (int)$page;
    $this->per_page = (int)$per_page;
    $this->total_count = (int)$total_count;
  }

  public function offset() {
    // Assuming 20 items per page:
    // page 1 has an offset of 0    (1-1) * 20
    // page 2 has an offset of 20   (2-1) * 20
    //   in other words, page 2 starts with item 21
    return ($this->current_page - 1) * $this->per_page;
  }

  public function total_pages() {
  	if($this->per_page == 0) {
  		$this->total_count = 1;
  	} else {
    	return ceil($this->total_count/$this->per_page); 		
  	}

	}
	
  public function previous_page() {
    return $this->current_page - 1;
  }
  
  public function next_page() {
    return $this->current_page + 1;
  }

	public function has_previous_page() {
		return $this->previous_page() >= 1 ? true : false;
	}

	public function has_next_page() {
		return $this->next_page() <= $this->total_pages() ? true : false;
	}
	public function items_per_page($item_array) {
		echo '<select name="imgPage" id="imgPage">';
		foreach($item_array as $item) {
			if((int)$item) {
				if($this->per_page == $item){
					echo '<option value="'.$item.'" selected="selected">'.$item.'</option>';
				} else {
					echo '<option value="'.$item.'">'.$item.'</option>';
				}
			} elseif($item == 'All') {
				if($this->per_page == $item){
					echo '<option value="'.$item.'" selected="selected">'.$item.'</option>';
				} else {
					echo '<option value="'.$item.'">'.$item.'</option>';
				}
			}
		}
		echo '</select>';
	}

	
	public static function create_pagination_ajax($currentPage=1,$range,$totalPages) {
		if($currentPage != 1) {
				echo '<span id="'.($currentPage - 1).'" class="page">&laquo; Previous</span>';
			}
			if($currentPage >= ($range + 3)) {
				echo '<span id="1" class="page">1</span>';
				echo '<span id="'.$totalPages.'" class="ellipse">...</span>';
			} elseif ($currentPage == ($range + 2)) {
				echo '<span id="1" class="page">1</span>';
			}
			for($i = ($currentPage - $range);$i < (($currentPage + $range) + 1); $i++) {
				if(($i > 0) && ($i <= $totalPages)){
					if($i == $currentPage){
						echo '<span id="'.$i.'" class="current">'.$i.'</span>';
					} else {
						echo '<span id="'.$i.'" class="page">'.$i.'</span>';
					}
				}
			}
			if($currentPage < ($totalPages - $range - 1)) {
				echo '<span id="'.$totalPages.'" class="ellipse">...</span>';
				echo '<span id="'.$totalPages.'" class="page">'.$totalPages.'</span>';
			} elseif ($currentPage == ($totalPages - $range - 1)) {
				echo '<span id="'.$totalPages.'" class="page">'.$totalPages.'</span>';
			}
			if($currentPage != $totalPages) {
				echo '<span id="'.($currentPage + 1).'" class="page" style="margin-right:0;">Next &raquo;</span>';
			}
	}
	function curPageURL() {
	 
	}
	public static function create_pagination_static($currentPage=1,$range,$totalPages) {
		$pageURL = parse_url($_SERVER['REQUEST_URI'],PHP_URL_PATH);
		 //print_r($pageURL);
		if($currentPage != 1) {
				if(($currentPage - 1) == 1) {
					echo '<a href="'.$pageURL.'" id="'.($currentPage - 1).'" class="page previous">&laquo; Previous</a>';
				} else {
					echo '<a href="'.$pageURL.'?page='.($currentPage - 1).'" id="'.($currentPage - 1).'" class="page previous">&laquo; Previous</a>';
				}
			}
			if($currentPage >= ($range + 3)) {
				echo '<a href="'.$pageURL.'" id="1" class="page">1</a>';
				echo '<span href="'.$pageURL.'" id="'.$totalPages.'" class="ellipse">...</span>';
			} elseif ($currentPage == ($range + 2)) {
				echo '<a href="'.$pageURL.'?" id="1" class="page">1</a>';
			}
			for($i = ($currentPage - $range);$i < (($currentPage + $range) + 1); $i++) {
				if(($i > 0) && ($i <= $totalPages)){
					if($i == $currentPage){
						echo '<span href="'.$pageURL.'?page='.$i.'" id="'.$i.'" class="current">'.$i.'</span>';
					} else {
						if($i == 1) {
							echo '<a href="'.$pageURL.'" id="'.$i.'" class="page">'.$i.'</a>';
						} else {
							echo '<a href="'.$pageURL.'?page='.$i.'" id="'.$i.'" class="page">'.$i.'</a>';
						}
						
					}
				}
			}
			if($currentPage < ($totalPages - $range - 1)) {
				echo '<span id="'.$totalPages.'" class="ellipse">...</span>';
				echo '<a href="'.$pageURL.'?page='.$totalPages.'" id="'.$totalPages.'" class="page">'.$totalPages.'</a>';
			} elseif ($currentPage == ($totalPages - $range - 1)) {
				echo '<a href="'.$pageURL.'" id="'.$totalPages.'" class="page">'.$totalPages.'</a>';
			}
			if($currentPage != $totalPages) {
				echo '<a href="'.$pageURL.'?page='.($currentPage + 1).'" id="'.($currentPage + 1).'" class="page next" style="margin-right:0;">Next &raquo;</a>';
			}
	}

}

?>